/*
 *  linux/arch/ba/board/config.c
 *
 *  BA version
 *    author(s): Simon Srot (srot@opencores.org)
 *
 *  For more information about BA processors, licensing and
 *  design services you may contact Beyond Semiconductor at
 *  sales@beyondsemi.com or visit website http://www.beyondsemi.com.
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file COPYING in the main directory of this archive
 * for more details.
 *
 * Based on m68knommu/platform/xx/config.c
 */

#include <stdarg.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/console.h>
#include <linux/device.h>
#include <linux/serial_8250.h>

#include <asm/system.h>
#include <asm/pgtable.h>
#include <asm/irq.h>
#include <asm/serial.h>

static struct plat_serial8250_port serial_platform_data[] = {
	{
		.iobase		= UART_BASE_ADD,
		.irq		= 19,
		.uartclk	= SYS_CLK,
		.regshift	= 0,
		.iotype		= UPIO_PORT,
		.flags		= UPF_BOOT_AUTOCONF,
	},
	{ },
};

static struct platform_device serial_device = {
	.name			= "serial8250",
	.id			= PLAT8250_DEV_PLATFORM,
	.dev			= {
		.platform_data	= serial_platform_data,
	},
};

int __init config_serial(void)
{
	platform_device_register(&serial_device);
	return 0;
}
arch_initcall(config_serial);
