#ifndef __AEONR2_BOARD_H__
#define __AEONR2_BOARD_H__

/* System clock frequecy */
#define SYS_CLK		(CONFIG_AEONR2_SYS_CLK*1000000)
#define SYS_CLK_PERIOD  (1000/CONFIG_AEONR2_SYS_CLK)

/* Memory organization */
#define SRAM_BASE_ADD   0x00000000
#define FLASH_BASE_ADD  0xf0000000

/* Devices base address */
#define UART_BASE_ADD   0x90000000

/* Define this if you want to use I and/or D cache */
#define IC_SIZE         CONFIG_AEONR2_IC_SIZE
#define IC_LINE         CONFIG_AEONR2_IC_LINE
#define IC_WAY		CONFIG_AEONR2_IC_WAY
#define DC_SIZE         CONFIG_AEONR2_DC_SIZE
#define DC_LINE         CONFIG_AEONR2_DC_LINE
#define DC_WAY		CONFIG_AEONR2_DC_WAY

/* Define this if you want to use I and/or D MMU */

#define DMMU_SET_NB     CONFIG_AEONR2_DTLB_ENTRIES
#define IMMU_SET_NB     CONFIG_AEONR2_ITLB_ENTRIES

/* Uart definitions */
#define UART_DLL        0       /* Out: Divisor Latch Low (DLAB=1) */
#define UART_DLM        1       /* Out: Divisor Latch High (DLAB=1) */

#define AEONR2_CONSOLE_BAUD	38400
#define UART_DIVISOR	SYS_CLK/(16*AEONR2_CONSOLE_BAUD)

/* Define ethernet MAC address */
#define MACADDR0	0x00
#define MACADDR1	0xba
#define MACADDR2	0x00
#define MACADDR3	0x00
#define MACADDR4	0x00
#define MACADDR5	0x00

#endif /* __AEONR2_BOARD_H__ */

