#include <asm/byteorder.h>

#define RIU_BASE_ADDR		0xa0000000
#define MHEG5_BANK_ADDR(x)	(RIU_BASE_ADDR+(((0x0F00)+((x)<<1))<<1))

#define DCUCMD_ADDR_H_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x41))))
#define DCUCMD_ADDR_L_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x42))))
#define DCUCMD_DATAIN_H_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x43))))
#define DCUCMD_DATAIN_L_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x44))))
#define DCUCMD_DATAOUT_H_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x45))))
#define DCUCMD_DATAOUT_L_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x46))))
#define DCUCMD_DEBUG_CMD_REG	(*((unsigned long volatile *)(MHEG5_BANK_ADDR(0x47))))

void aeon_dcache_flush(void)
{
	DCUCMD_DEBUG_CMD_REG |= 0x03800000;
	DCUCMD_DEBUG_CMD_REG |= 0x03800000;
	DCUCMD_DEBUG_CMD_REG |= 0x03800000;
	while (DCUCMD_DEBUG_CMD_REG & 0x00800000)
		DCUCMD_DATAOUT_L_REG = 0xFFFFFFFF;
}

void aeon_dcache_inv(void)
{
	DCUCMD_DEBUG_CMD_REG |= 0x0b800000;
	DCUCMD_DEBUG_CMD_REG |= 0x0b800000;
	DCUCMD_DEBUG_CMD_REG |= 0x0b800000;
	while (DCUCMD_DEBUG_CMD_REG & 0x00800000)
		DCUCMD_DATAOUT_L_REG = 0xFFFFFFFF;
}

void aeon_sync_writebuffer(void)
{
	DCUCMD_DEBUG_CMD_REG |= 0x01800000;
	DCUCMD_DEBUG_CMD_REG |= 0x01800000;
	DCUCMD_DEBUG_CMD_REG |= 0x01800000;
	while (DCUCMD_DEBUG_CMD_REG & 0x00800000)
		DCUCMD_DATAOUT_L_REG = 0xFFFFFFFF;
}

void aeon_dcache_read(unsigned long addr)
{
	addr -= 0xc0000000;
	DCUCMD_ADDR_H_REG = (addr >> 15);
	DCUCMD_ADDR_L_REG = (addr & 0xfffe);
	DCUCMD_DEBUG_CMD_REG |= 0x0f800000;
	while (DCUCMD_DEBUG_CMD_REG & 0x00800000) ;
	printk("DATA_OUT_H:0x%x\n", DCUCMD_DATAOUT_H_REG);
	printk("DATA_OUT_L:0x%x\n", DCUCMD_DATAOUT_L_REG);

	DCUCMD_ADDR_H_REG = (addr >> 15);
	DCUCMD_ADDR_L_REG = ((addr & 0xffff) | 0x1);
	DCUCMD_DEBUG_CMD_REG |= 0x0f800000;
	while (DCUCMD_DEBUG_CMD_REG & 0x00800000) ;
	printk("DATA_OUT_H:0x%x\n", DCUCMD_DATAOUT_H_REG);
	printk("DATA_OUT_L:0x%x\n", DCUCMD_DATAOUT_L_REG);
}

