#include <linux/delay.h>
#include <linux/jiffies.h>
#include <asm/param.h>

#ifdef CONFIG_SMP
#define LPJ      cpu_data[smp_processor_id()].loops_per_jiffy
#else
#define LPJ      loops_per_jiffy
#endif

/*
 * usec  <= 2000
 * lpj   <= 0x01ffffff (max. 3355 bogomips)
 * HZ    <= 1000
 */
    

void __udelay(unsigned long usecs)
{
  unsigned long loops, t;

  loops = ((2199023*HZ)>>11)*usecs; /* 0 <= loops <= 0x7fffff06 */
  
  loops = loops >> 14;              /* max = 0x0001ffff         */
  t     = LPJ   >> 10;              /* max = 0x00007fff         */

  loops = loops * t;                /* max = 2^32-1             */
  loops = loops >> 6;

  /* loops = r0 * HZ * loops_per_jiffy / 1000000 */
  __delay((int)loops);
}
