
#include <linux/linkage.h>
#include <asm/page.h>
#include <asm/spr_defs.h>

#define CONFIG_TLB_INV_IH 0x0

/* TLB flushing things, written in 100% pure assembly, just like how it was
 * supposed to be written right from the begining.. */

ENTRY(_flush_tlb_all_nommu)
	b.ori	r3,r0,0
#if 1//AEONR2 HACK
	b.ori	r4,r0,CONFIG_AEONR2_ITLB_ENTRIES
#endif
1:	b.mtspr	r0,r3,SPR_DTLBEIR
	b.ori	r5,r0,SPR_ITLBEIR
	b.mtspr	r5,r3,0
	b.addi	r4,r4,-1
	b.addi	r3,r3,(1 << PAGE_SHIFT)
	b.sfnei	r4,0
	b.bf	1b

	b.jr	r9

/* SPR_SR value is saved to r11 */
#define FLUSH_ENTRY 					;\
	b.addi	r1,r1,-36				;\
	b.sw	32(r1),r3				;\
	b.sw	28(r1),r4				;\
	b.sw	24(r1),r5				;\
	b.sw	20(r1),r6				;\
	b.sw	16(r1),r7				;\
	b.sw	12(r1),r8				;\
	b.sw	8(r1),r9				;\
	b.sw	4(r1),r10				;\
	b.sw	0(r1),r11				;\
	b.addi	r10,r1,12				;\
							;\
	b.movhi	r7,hi(99f)				;\
	b.ori	r7,r7,lo(99f)				;\
	b.movhi	r8,hi(KERNELBASE)			;\
	b.sub	r8,r7,r8				;\
							;\
	b.mfspr	r11,r0,SPR_SR				;\
	b.andi	r7,r11,lo(~(SPR_SR_IEE | SPR_SR_TEE))	;\
	b.mtspr	r0,r7,SPR_SR				;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
							;\
	b.j	1f					;\
.align	0x20						;\
1:							;\
	b.mtspr	r0,r8,SPR_EPCR_BASE			;\
	b.mfspr	r8,r0,SPR_SR				;\
	b.andi	r8,r8,lo(~(SPR_SR_IME | SPR_SR_DME))	;\
	b.mtspr	r0,r8,SPR_ESR_BASE			;\
	b.rfe						;\
99:							;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0

/* r11 should hold the desired (previously saved) SPR_SR value */
#define FLUSH_EXIT					;\
	b.movhi	r7,hi(99f)				;\
	b.ori	r7,r7,lo(99f)				;\
	b.j	1f					;\
.align 0x20						;\
1:							;\
	b.mtspr	r0,r7,SPR_EPCR_BASE			;\
	b.mfspr	r7,r0,SPR_SR				;\
	b.ori	r7,r7,lo(SPR_SR_IME | SPR_SR_DME)	;\
	b.mtspr	r0,r7,SPR_ESR_BASE			;\
	b.rfe						;\
99:							;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
							;\
	b.mtspr	r0,r11,SPR_SR				;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
	b.nop	0x0					;\
							;\
	b.lwz	r3,32(r1)				;\
	b.lwz	r4,28(r1)				;\
	b.lwz	r5,24(r1)				;\
	b.lwz	r6,20(r1)				;\
	b.lwz	r7,16(r1)				;\
	b.lwz	r8,12(r1)				;\
	b.lwz	r9,8(r1)				;\
	b.lwz	r10,4(r1)				;\
	b.lwz	r11,0(r1)				;\
	b.addi	r1,r1,36				;\
							;\
	b.jr	r9

ENTRY(_flush_tlb_all)
	FLUSH_ENTRY

	b.jal	_flush_tlb_all_nommu

	FLUSH_EXIT

ENTRY(_flush_tlb_page)
	FLUSH_ENTRY

	b.ori	r4,r4,CONFIG_TLB_INV_IH
	b.ori	r5,r0,SPR_ITLBEIR
	b.mtspr	r5,r4,0
	b.mtspr	r0,r4,SPR_DTLBEIR

	FLUSH_EXIT

ENTRY(_flush_tlb_range)
	FLUSH_ENTRY

1:	b.sfgeu	r4,r5
	b.bf	1f
	b.ori	r6,r4,CONFIG_TLB_INV_IH
	b.ori	r7,r0,SPR_ITLBEIR
	b.mtspr	r7,r6,0
	b.mtspr	r0,r6,SPR_DTLBEIR
	b.addi	r4,r4,(1 << PAGE_SHIFT)
	b.j	1b

1:
	FLUSH_EXIT

