/*
 * arch/ba/mm/ioremap_nommu.c
 *
 *  BA version
 *    author(s): Matjaz Breskvar (phoenix@beyondsemi.com)
 *
 *  For more information about BA processors, licensing and
 *  design services you may contact Beyond Semiconductor at
 *  sales@beyondsemi.com or visit website http://www.beyondsemi.com.
 *
 */

#include <linux/vmalloc.h>
#include <linux/io.h>
#include <asm/pgalloc.h>
#include <asm/cacheflush.h>
#include <asm/tlbflush.h>
#include <asm/kmap_types.h>
#include <asm/fixmap.h>
#include <asm/bug.h>

/*
 * In nommu version the remapping isn't neccessery (or possible).
 *
 */
void * __ioremap(unsigned long phys_addr, unsigned long size, unsigned long flags)
{
	return (void *)(phys_addr);
}

/*
 * Nothing done to remap -> nothing needed to unmap
 *
 */
void iounmap(void *addr)
{
}

