////////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2006-2007 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// (MStar Confidential Information) by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
////////////////////////////////////////////////////////////////////////////////

#include <linux/config.h>
#include <linux/device.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/resource.h>

#include "chip_int.h"

#define UTMI_BASE_ADDRESS_START 0xbf807500
#define UTMI_BASE_ADDRESS_END 0xbf8075FC
#define USB_HOST20_ADDRESS_START 0xbf804800
#define USB_HOST20_ADDRESS_END 0xbf8049FC

static struct resource Mstar_usb_ehci_resources[] = {
	[0] = {
		.start		= UTMI_BASE_ADDRESS_START,
		.end		= UTMI_BASE_ADDRESS_START,
		.flags		= IORESOURCE_MEM,
	},
	[1] = {
		.start		= USB_HOST20_ADDRESS_START,
		.end		= USB_HOST20_ADDRESS_END,
		.flags		= IORESOURCE_MEM,
	},
	[2] = {
		.start		= E_IRQ_UHC,
		.end		= E_IRQ_UHC,
		.flags		= IORESOURCE_IRQ,
	},
};

/* The dmamask must be set for EHCI to work */
#if CONFIG_MSTAR_TITANIA_BD_MST055E_D01A_S
static u64 ehci_dmamask = ~(u32)0;
#else
static u64 ehci_dmamask = 0xffffff;	//tony limited range for MIU0
#endif

static struct platform_device Mstar_usb_ehci_device = {
	.name		= "Mstar-soc-ehci",
	.id		= 0,
	.dev = {
		.dma_mask		= &ehci_dmamask,
#if CONFIG_MSTAR_TITANIA_BD_MST055E_D01A_S
		.coherent_dma_mask	= 0xffffffff,
#else
		.coherent_dma_mask	= 0xffffff,	//tony limited range for MIU0
#endif
	},
	.num_resources	= ARRAY_SIZE(Mstar_usb_ehci_resources),
	.resource	= Mstar_usb_ehci_resources,
};

static struct platform_device *Mstar_platform_devices[] __initdata = {
	&Mstar_usb_ehci_device,
};

int Mstar_platform_init(void)
{
	return platform_add_devices(Mstar_platform_devices, ARRAY_SIZE(Mstar_platform_devices));
}

arch_initcall(Mstar_platform_init);
