///////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2008-2009 MStar Semiconductor, Inc.
// All rights reserved.
//
// Unless otherwise stipulated in writing, any and all information contained
// herein regardless in any format shall remain the sole proprietary of
// MStar Semiconductor Inc. and be kept in strict confidence
// ("MStar Confidential Information") by the recipient.
// Any unauthorized act including without limitation unauthorized disclosure,
// copying, use, reproduction, sale, distribution, modification, disassembling,
// reverse engineering and compiling of the contents of MStar Confidential
// Information is unlawful and strictly prohibited. MStar hereby reserves the
// rights to any and all damages, losses, costs and expenses resulting therefrom.
//
///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
//
// @file   mdrv_gflip_io.h
// @brief  GFlip KMD Driver Interface
// @author MStar Semiconductor Inc.
//////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _MDRV_GFLIP_IO_H
#define _MDRV_GFLIP_IO_H

//=============================================================================
// Includs
//=============================================================================
#include "mdrv_gflip_st.h"

//=============================================================================
// Defines
//=============================================================================
//IO Ctrl defines:
#define MDRV_GFLIP_IOC_INIT_NR        0
#define MDRV_GFLIP_IOC_DEINIT_NR      MDRV_GFLIP_IOC_INIT_NR+1
#define MDRV_GFLIP_IOC_SETFLIPINFO_NR   MDRV_GFLIP_IOC_DEINIT_NR+1
#define MDRV_GFLIP_IOC_SETINPUTSIGSTATUS_NR    MDRV_GFLIP_IOC_SETFLIPINFO_NR+1
#define MDRV_GFLIP_IOC_GETDWININTINFO_NR    MDRV_GFLIP_IOC_SETINPUTSIGSTATUS_NR+1

#define MDRV_GFLIP_IOC_MAX_NR       MDRV_GFLIP_IOC_GETDWININTINFO_NR+1

// use 'm' as magic number
#define MDRV_GFLIP_IOC_MAGIC      '2'
#define MDRV_GFLIP_IOC_INIT                     _IOR(MDRV_GFLIP_IOC_MAGIC,   MDRV_GFLIP_IOC_INIT_NR, MS_U32)
//#define MDRV_GFLIP_IOC_DEINIT     _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_DEINIT_NR, MS_U32)
#define MDRV_GFLIP_IOC_SETFLIPINFO       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_SETFLIPINFO_NR, MS_GFLIP_INFO)
#define MDRV_GFLIP_IOC_SETINPUTSIGSTATUS    _IOR(MDRV_GFLIP_IOC_MAGIC,   MDRV_GFLIP_IOC_SETINPUTSIGSTATUS_NR, MS_BOOL)
#define MDRV_GFLIP_IOC_GETDWININTINFO       _IOWR(MDRV_GFLIP_IOC_MAGIC, MDRV_GFLIP_IOC_GETDWININTINFO_NR, MS_GFLIP_DWININT_INFO)

#endif //_MDRV_GFLIP_IO_H
