//===========================================================
// error codes
//===========================================================
#define  UNFD_ST_SUCCESS					0

#define  UNFD_ERRCODE_GROUP_MASK			0xF0000000

//===========================================================
// for NAND Programmer
//    - NAND Programmer is asked to exist with types of OS,
//      as a result uses different Macros defined here.
//===========================================================
#if defined(NAND_DRIVER_PROGRAMMER) && NAND_DRIVER_PROGRAMMER
#define  UNFD_ST_NPRG						0x90000000
#define  UNFD_ST_NPRGERR_NO_NFIE			(0x01 | UNFD_ST_NPRG)
#define  NAND_ST_NPRGERR_CIS_NAND_ERR		(0x02 | UNFD_ST_NPRG)
#endif

//===========================================================
// for NonOS functions
//===========================================================
#if defined(NAND_DRIVER_OS_NOS) && NAND_DRIVER_OS_NOS
#define  UNFD_ST_NOS						0xA0000000
#define  UNFD_ST_ERR_NO_NFIE				(0x01 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_UNKNOWN_RSEQ			(0x02 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_UNKNOWN_ECC_TYPE		(0x03 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_NO_CIS					(0x04 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_CIS0_ECCERR			(0x05 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_CIS1_ECCERR			(0x06 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_E_TIMEOUT				(0x07 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_W_TIMEOUT				(0x08 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_R_TIMEOUT				(0x09 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_2L_MAP2_1P				(0x0A | UNFD_ST_NOS)
#define  UNFD_ST_ERR_INVALID_PART			(0x0B | UNFD_ST_NOS)
#define  UNFD_ST_ERR_INVALID_ADDR			(0x0C | UNFD_ST_NOS)
#define  UNFD_ST_ERR_ECC_FAIL				(0x0D | UNFD_ST_NOS)
#define  UNFD_ST_ERR_EXCEED_CAPACITY		(0x0E | UNFD_ST_NOS)
#define  UNFD_ST_ERR_RST_TIMEOUT			(0x0F | UNFD_ST_NOS)
#define  UNFD_ST_ERR_MIU_RPATCH_TIMEOUT		(0x10 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_HAL_R_INVALID_PARAM	(0x11 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_HAL_W_INVALID_PARAM	(0x12 | UNFD_ST_NOS)
#define  UNFD_ST_ERR_R_TIMEOUT_RM			(0x13 | UNFD_ST_NOS)	// R Operation in RIU Mode
#define  UNFD_ST_ERR_ECC_FAIL_RM			(0x14 | UNFD_ST_NOS)	// R Operation in RIU Mode
#define  UNFD_ST_ERR_W_TIMEOUT_RM			(0x15 | UNFD_ST_NOS)	// W Operation in RIU Mode
#define  UNFD_ST_ERR_PLAT_INIT_0			(0x16 | UNFD_ST_NOS)	// malloc return NULL
#endif

//===========================================================
// for eCos functions
//===========================================================
#if defined(NAND_DRIVER_OS_ECOS) && NAND_DRIVER_OS_ECOS
#define  UNFD_ST_ECOS						0xB0000000
#define  UNFD_ST_ERR_NO_NFIE				(0x01 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_UNKNOWN_RSEQ			(0x02 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_UNKNOWN_ECC_TYPE		(0x03 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_NO_CIS					(0x04 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_CIS0_ECCERR			(0x05 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_CIS1_ECCERR			(0x06 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_E_TIMEOUT				(0x07 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_W_TIMEOUT				(0x08 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_R_TIMEOUT				(0x09 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_2L_MAP2_1P				(0x0A | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_IOLUP_FAIL				(0x0B | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_DISKINIT_FAIL			(0x0C | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_DISKCONN_FAIL			(0x0D | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_INVALID_ADDR			(0x0E | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_ECC_FAIL				(0x0F | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_EXCEED_CAPACITY		(0x10 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_DISK_CONN_FAIL			(0x11 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_RST_TIMEOUT			(0x12 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_MIU_RPATCH_TIMEOUT		(0x13 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_HAL_R_INVALID_PARAM	(0x14 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_HAL_W_INVALID_PARAM	(0x15 | UNFD_ST_ECOS)
#define  UNFD_ST_ERR_R_TIMEOUT_RM			(0x16 | UNFD_ST_ECOS)	// R Operation in RIU Mode
#define  UNFD_ST_ERR_ECC_FAIL_RM			(0x17 | UNFD_ST_ECOS)	// R Operation in RIU Mode
#define  UNFD_ST_ERR_W_TIMEOUT_RM			(0x18 | UNFD_ST_ECOS)	// W Operation in RIU Mode
#define  UNFD_ST_ERR_PLAT_INIT_0			(0x19 | UNFD_ST_ECOS)	// malloc return NULL
#endif

//===========================================================
// for HAL functions
//===========================================================
#if defined(NAND_DRV_LINUX) && NAND_DRV_LINUX
#define  UNFD_ST_LINUX						0xC0000000
#define  UNFD_ST_ERR_NO_NFIE				(0x01 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_E_TIMEOUT				(0x07 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_W_TIMEOUT				(0x08 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_R_TIMEOUT				(0x09 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_ECC_FAIL				(0x0F | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_RST_TIMEOUT			(0x12 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_MIU_RPATCH_TIMEOUT		(0x13 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_HAL_R_INVALID_PARAM	(0x14 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_HAL_W_INVALID_PARAM	(0x15 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_R_TIMEOUT_RM			(0x16 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_ECC_FAIL_RM			(0x17 | UNFD_ST_LINUX)
#define  UNFD_ST_ERR_W_TIMEOUT_RM			(0x18 | UNFD_ST_LINUX)
#endif

//===========================================================
// for HAL functions
//===========================================================
#define  UNFD_ST_RESERVED					0xE0000000
#define  UNFD_ST_ERR_E_FAIL					(0x01 | UNFD_ST_RESERVED)
#define  UNFD_ST_ERR_W_FAIL					(0x02 | UNFD_ST_RESERVED)
#define  UNFD_ST_ERR_E_BUSY					(0x03 | UNFD_ST_RESERVED)
#define  UNFD_ST_ERR_W_BUSY					(0x04 | UNFD_ST_RESERVED)
#define  UNFD_ST_ERR_E_PROTECTED			(0x05 | UNFD_ST_RESERVED)
#define  UNFD_ST_ERR_W_PROTECTED			(0x06 | UNFD_ST_RESERVED)

//===========================================================
// for IP_Verify functions
//===========================================================
#define  UNFD_ST_IP							0xF0000000
#define  UNFD_ST_ERR_UNKNOWN_ID				(0x01 | UNFD_ST_IP)
#define  UNFD_ST_ERR_DATA_CMP_FAIL			(0x02 | UNFD_ST_IP)
#define  UNFD_ST_ERR_INVALID_PARAM			(0x03 | UNFD_ST_IP)
#define  UNFD_ST_ERR_INVALID_ECC_REG51		(0x04 | UNFD_ST_IP)
#define  UNFD_ST_ERR_INVALID_ECC_REG52		(0x05 | UNFD_ST_IP)
#define  UNFD_ST_ERR_INVALID_ECC_REG53		(0x06 | UNFD_ST_IP)
#define  UNFD_ST_ERR_SIGNATURE_FAIL			(0x07 | UNFD_ST_IP)
