/*
 * Copyright (C) 2008, OGAWA Hirofumi
 * Released under GPL v2.
 */

#ifndef _EXFAT_CLUSTER_H
#define _EXFAT_CLUSTER_H

struct exfat_clus_map {
	u32	iclusnr;		/* cluster number on data of inode. */
	u32	clusnr;			/* cluster number on disk. */
	u32	len;			/* number of contiguous clusters */
};

int exfat_get_cluster(struct inode *inode, u32 iclusnr, u32 clus_len,
		      struct exfat_clus_map *cmap);

int exfat_add_cluster(struct inode *inode, u32* iclusnr);
int exfat_allocate_clusters(struct inode *inode, int *cluster, int nr_cluster);
int exfat_write_entry(struct inode *inode, u32 clusnr,u32 valuetoset);
int exfat_free_clusters(struct inode *inode, u32 clusnr,int clus_len);
int exfat_clear_cluster(struct inode *dir,int clus);



#endif /* !_EXFAT_CLUSTER_H */
