/*
 * Copyright (C) 2008, OGAWA Hirofumi
 * Released under GPL v2.
 */

#ifndef _EXFAT_FATENT_H
#define _EXFAT_FATENT_H

#include <linux/buffer_head.h>

struct exfat_ent {
	struct buffer_head *bh;
	u32 offset;
};

void exfat_ent_init(struct exfat_ent *fatent);
void exfat_ent_release(struct exfat_ent *fatent);
int exfat_ent_read(struct inode *inode,
				 struct exfat_ent *fatent,
				 u32 clusnr, u32 *result_clusnr);

int exfat_ent_prepare(struct inode *inode,
				    struct exfat_ent *fatent,
				    u32 clusnr, u32 *result_clusnr);
				 
void exfat_ent_write(struct inode *inode,
				   struct exfat_ent *fatent,
				   u32 new_clusnr);


#endif /* !_EXFAT_FATENT_H */
